package mc600.gamemanager;

/**
 * Classe que implementa uma fila circular de jogadores, em um vetor.
 * 
 * Creation date: (3/25/00 8:08:59 PM)
 * @author: 
 */
class PlayerQueue {
    public PlayerClient[] players;
    private int nPlayers;	// numero real de jogadores (pode ser impar)

    public PlayerQueue(PlayerClient[] p, int nPlayers) {
	super();

	this.nPlayers = nPlayers;
	players = new PlayerClient[nPlayers];

	// copia todos os valores.........

	for(int i=0; i < nPlayers; i++)
	    players[i] = p[i];
    }

    /**
     * Insert the method's description here.
     * Creation date: (3/25/00 8:53:26 PM)
     * @return mc600.gamemanager.PlayerClient
     */
    public PlayerClient getPlayer(int i) {
	return players[i];
    }

    /**
     * Insert the method's description here.
     * Creation date: (3/25/00 8:24:05 PM)
     * @return int
     */
    public int nPlayers() {
	return nPlayers;
    }

    /** This is a generic version of C.A.R Hoare's Quick Sort
     * algorithm.  This will handle arrays that are already
     * sorted, and arrays with duplicate keys.
     *
     * If you think of a one dimensional array as going from
     * the lowest index on the left to the highest index on the right
     * then the parameters to this function are lowest index or
     * left and highest index or right.  The first time you call
     * this function it will be with the parameters 0, a.length - 1.
     *
     * @param a       an integer array
     * @param lo0     left boundary of array partition
     * @param hi0     right boundary of array partition
     */
    private void QuickSort(PlayerClient a[], int lo0, int hi0) {
	int lo = lo0;
	int hi = hi0;
	PlayerClient mid;
	
	if ( hi0 > lo0) {
	    
	    // Arbitrarily establishing partition element as the
	    // midpoint of the array.
	    
	    mid = a[ ( lo0 + hi0 ) / 2 ];
	    
	    // loop through the array until indices cross
	    while( lo <= hi ) {
		// find the first element that is greater than or equal to
		// the partition element starting from the left Index.
		while( ( lo < hi0 ) && 
		       ( a[lo].getVictoryCount() < mid.getVictoryCount() ))
		    ++lo;
		
		// find an element that is smaller than or equal to
		// the partition element starting from the right Index.
		while( ( hi > lo0 ) && 
		       ( a[hi].getVictoryCount() > mid.getVictoryCount() ))
		    --hi;
		
		// if the indexes have not crossed, swap
		if( lo <= hi )
		    {
			swap(a, lo, hi);
			++lo;
			--hi;
		    }
	    }
	    
	    // If the right index has not reached the left side of array
	    // must now sort the left partition.
	    if( lo0 < hi )
		QuickSort( a, lo0, hi );
	    
	    // If the left index has not reached the right side of array
	    // must now sort the right partition.
	    if( lo < hi0 )
		QuickSort( a, lo, hi0 );
	}
    }   

    public void sort() {
	   
	QuickSort(players, 0, nPlayers-1);

    }   

    private void swap(PlayerClient a[], int i, int j) {

	PlayerClient T;
	T = a[i];
	a[i] = a[j];
	a[j] = T;
    }
}
